[![Jenkins](https://img.shields.io/badge/Build-Jenkins-brightgreen)](https://warpdrive.dev.symphony.com/jenkins/job/SymphonyOSF/job/symphony-agent/)
[![Tests](https://img.shields.io/badge/Tests-Jenkins-brightgreen)](https://warpdrive-lab.dev.symphony.com/jenkins/view/DevX-Jackfruit/)
[![Sonar](https://img.shields.io/badge/Code%20Quality-Sonar-blue)](https://warpdrive.dev.symphony.com/sonar/overview?id=com.symphony%3Asymphony-agent)
[![Snyk](https://img.shields.io/badge/Security-Snyk-7530a6)](https://app.snyk.io/org/developer-experience-ab1/project/742c298b-b5d6-43bb-ad16-9b558a407f3e)
[![Confluence](https://img.shields.io/badge/Wiki-Confluence-lightblue)](https://perzoinc.atlassian.net/wiki/spaces/DevX/pages/697797287/13.+Agent)
[![Jira](https://img.shields.io/badge/Issues-Jira-lightblue)](https://perzoinc.atlassian.net/jira/software/c/projects/AGNT/boards/996)

# Symphony Agent

The Agent is a service responsible for encrypting and decrypting data (messages, realtime events, signals,...) for apps
and bots. It is deployed on-premise and on-cloud.

The Agent is maintained by the Solution Framework team, you can reach out to the team in Symphony,
[Rest Calls & Agent APIs Internal Support room](symphony://?streamId=z6KWAgiFjNLDjWsw3XIOGn///rPyKjKGdA==&streamType=chatroom)
. The [Symphony Developers Documentation](https://docs.developers.symphony.com/admin-guide/agent-guide) and
the [Wiki](https://perzoinc.atlassian.net/wiki/spaces/DevX/pages/697797287/13.+Agent) are also good places to start.

## Usage

The Agent can be downloaded from
the [Symphony Developers Documentation](https://docs.developers.symphony.com/admin-guide/change-log/agent). On this site
you will find also find a [guide](https://docs.developers.symphony.com/admin-guide/agent-guide) to get you started with
the Agent when running it on-premises.

The Agent is also published as a Docker image across different repositories, internals to Symphony.

## Development

### Prerequisites

Agent is built with:

- Java JDK 17
- Maven

#### Maven Artifactory settings

Create `settings.xml` in your local Maven repository (`~/.m2/settings.xml`).\
This is necessary in order to fetch the project dependencies from Symphony's Artifactory.\
The content of `settings.xml` should be like the following:

```xml
<?xml version="1.0" encoding="UTF-8"?>
<settings xsi:schemaLocation="http://maven.apache.org/SETTINGS/1.1.0 http://maven.apache.org/xsd/settings-1.1.0.xsd"
          xmlns="http://maven.apache.org/SETTINGS/1.1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
    <servers>
        <server>
            <username>
                <ARTIFACTORY_USER_PROFILE>
            </username>
            <password>
                <API_KEY>
            </password>
            <id>symphony-local-dev</id>
        </server>
        <server>
            <username>
                <ARTIFACTORY_USER_PROFILE>
            </username>
            <password>
                <API_KEY>
            </password>
            <id>symphony</id>
        </server>
        <server>
            <username>
                <ARTIFACTORY_USER_PROFILE>
            </username>
            <password>
                <API_KEY>
            </password>
            <id>snapshots</id>
        </server>
    </servers>
</settings>
```

- Replace `ARTIFACTORY_USER_PROFILE` by your Symphony email.
- Replace `API_KEY` by the API Key found in
  your [Artifactory user profile](https://repo.symphony.com/artifactory/webapp/#/profile).

### Build

From the root, run:

> mvn install

### Run

The Agent can be executed from your IDE as a Spring Boot application or with the command line. It starts on port 9443 by
default. You probably want to adapt the [configuration](./agent/src/main/resources/agent.yml) to your environment.

> mvn spring-boot:run -pl agent

You can then check it is running with the healthcheck: https://localhost:9443/agent/v3/health. The Agent API is fully
documented in the [Symphony Developers REST API reference](https://developers.symphony.com/restapi/reference).

### CI

When opening a PR or building master branch, there are 2 PR builders running:
* Legacy build in https://warpdrive.dev.symphony.com/jenkins/blue/organizations/jenkins/SymphonyOSF%2Fsymphony-agent
* GCP build in https://jenkins.gke-use4-tools-001.symphony.com/blue/organizations/jenkins/build-agent%2FSymphonyOSF%2Fsymphony-agent

### Release

https://perzoinc.atlassian.net/wiki/spaces/DevX/pages/3600056334/Symphony+Agent+-+Release+Process+-+Latest
